package esercizio1;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class AziendaSanitaria {

	private List<Medico> medici;
    private List<Paziente> pazienti;
    
    public AziendaSanitaria(){
          medici=new ArrayList<Medico>();
          pazienti=new ArrayList<Paziente>();
    }
    
    public AziendaSanitaria(List<Medico> listaMedici, List<Paziente> listaPazienti) {
    	this.medici = listaMedici;
    	this.pazienti = listaPazienti;
    }
    
    public boolean aggiungiPaziente(int unaTessera, Medico m)
	{
		boolean result = false;
		
		/*Verifico che il medico sia presente all'interno dell'azienda sanitaria*/
		if(trovaMedico(m)) {
			/*Verifico che il paziente non sia gi presente all'interno della lista*/
			if(!trovaPaziente(unaTessera)) {
				pazienti.add(new Paziente(unaTessera, m));
				result = true;
			}
		}
		return result;	
	}
    
    // metodo di utilit
 	private boolean trovaMedico(Medico m) {
 		boolean trovato = false;
 		Iterator<Medico> iteratore = medici.iterator();
 		while(iteratore.hasNext() && !trovato) {
 			Medico temp = iteratore.next();
 			if(temp.getNominativo().equals(m.getNominativo()))
 				trovato = true;
 		}
 		return trovato;
 	}
 	
 	// metodo di utilit
 	private boolean trovaPaziente(int unaTessera) {
		boolean trovato = false;
		Iterator <Paziente> iteratore = pazienti.iterator();
		while(iteratore.hasNext() && !trovato) {
			Paziente temp = iteratore.next();
			if(temp.getNumeroTessera() == unaTessera)
				trovato = true;
		}
		return trovato;
	}
	
 	
    public boolean aggiungiMedico(Medico m) {
    		boolean result = false;
    		if(!trovaMedico(m)) {
    			medici.add(m);
    			result = true;
    		}
    		return result;
    }

    
	public ArrayList<Paziente> listaMedico(Medico medico){
		ArrayList<Paziente> result = new ArrayList<Paziente>();
		
		Iterator <Paziente> iteratore = pazienti.iterator();
		while(iteratore.hasNext()) {
			Paziente p = iteratore.next();
			if(p.getMedicoCurante().getNominativo().equals(medico.getNominativo()))
				result.add(p);
		}
		
		return result;
	}
	
	// prima versione, senza riuso di metodi precedenti. Soluzione pi complessa.
	public Medico statMedico(){
		int maxPazienti = 0;
		Medico result = null;
		Iterator<Medico> iteratorM = medici.iterator();
		while(iteratorM.hasNext()) {
			Medico med = iteratorM.next();
			int numPazienti = 0;
			/*Conto i pazienti per il Medico med*/
			Iterator <Paziente> iteratorP = pazienti.iterator();
			while(iteratorP.hasNext()) {
				Paziente p = iteratorP.next();
				if(p.getMedicoCurante().getNominativo().equals(med.getNominativo()))
					numPazienti++;
			}
			if(numPazienti > maxPazienti) {
				maxPazienti = numPazienti;
				result = med;
			}
		}
		return result;
	}
	
	/*
	// metodo alternativo con il riuso del metodo listaMedico
	public Medico statMedico() {
		int maxPazienti = 0;
		Medico result = null;
		Iterator<Medico> i = medici.iterator();
		while(i.hasNext()) {
			Medico m = i.next();
			if(listaMedico(m).size()>maxPazienti) {
				maxPazienti = listaMedico(m).size();
				result = m;
			}
		}
		return result;
	}
	*/
}
